package de.fraunhofer.iem.dataprovider.taskManager.tasks

import de.fraunhofer.iem.dataprovider.logger.getLogger
import de.fraunhofer.iem.dataprovider.taskManager.Event
import java.util.*

interface ITask {
    suspend fun execute()
    val taskID: UUID
}

sealed class Task : ITask {
    override val taskID: UUID = UUID.randomUUID()
    protected val logger = getLogger(javaClass)
    protected abstract val responseChannel: suspend (task: Event) -> Unit
}
